function A=tpm(A)
%code by Mukdam Kena and jph

if ~nargin
  A=struct;
  
  A.proj.title='noname';
  A.proj.csv='%10.4f;';
  A.proj.comment=[];
  A.proj.export=1;
  A.proj.notify.export=' > %s\n';
  A.proj.notify.import=' < %s\n';
  
  A.surf.samples.numel=[];
  A.surf.samples.x=[];
  A.surf.samples.y=[];
  A.surf.min.x=[];
  A.surf.max.x=[];
  A.surf.min.y=[];
  A.surf.max.y=[];
  A.surf.min.z=[];
  A.surf.max.z=[];
  A.surf.function=[];
  A.surf.curve.import=[];
  A.surf.curve.points=[];
  A.surf.curve.interp.method='linear';
  A.surf.curve.manual=[];
  A.surf.curve.rotation.degrees=[];
  A.surf.curve.rotation.radians=[];
  A.surf.curve.rotation.margin.absolute.min.y=[];
  A.surf.curve.rotation.margin.absolute.max.y=[];
  A.surf.curve.translation=[];
  A.surf.figure=1;
  A.surf.curvature.mean.c=[];    
  A.surf.curvature.radius.c=[];  
  A.surf.curvature.gauss.c=[]; 
  A.surf.curvature.figure=2;
  
  A.surf.distances=linspace(0,10,10);
  
  A.drill.shape=[];
  A.drill.radius=[];
  A.drill.slant.degrees=[];
  A.drill.slant.radians=[];
  A.drill.interp.resolution=12;
  A.drill.interp.x=[];
  A.drill.interp.y=[];
  A.drill.figure=3;
    
  A.path.streamlines=[];  
  A.path.parallel.lines.x=[];
  A.path.parallel.lines.y=[];  
  A.path.parallel.y=[];
  A.path.contour.lines=[];
  A.path.contour.figure=13;
  A.path.mesh.x=[];
  A.path.mesh.y=[];
  A.path.mesh.z=[];  
  A.path.segmentation.angle=1e-3;
  A.path.correct.method='';
  A.path.correct.figure=4;
  A.path.master.x=[];
  A.path.master.y=[];
  A.path.master.z=[];
  A.path.numel=1000;
  A.path.master.figure=5;
  A.path.palette={'b','g','r'};
  A.path.import.filename=[];
  A.path.import.index=[];  
  A.path.import.permute=1:3;
  A.path.import.translation=[0 0 0];
  A.path.export.translation=[0 0 0];
  A.path.import.figure=[];%6;
  A.path.x=[];
  A.path.y=[];
  A.path.z=[];
  A.path.direction='x';
  A.path.figure=7;
  A.path.analysis.figure=8;   
  
  A.mill.stencil.resolution=11; % HAS TO BE UNEVEN NUMBER
  A.mill.figure=9;
  A.mill.recursion=1;
  A.mill.plot.section.x=[];
  A.mill.plot.section.y=[];
  A.mill.interp.method='linear';
  return;
end

if ~isempty(A.proj.comment)
  str=A.proj.comment;
  while length(str)
    [tok,str]=strtok(str,'|');    
    fprintf(' | %s\n',tok);
  end
end

A.proj.directory=[A.proj.title '/'];
[success,message,messageid]=mkdir(A.proj.directory);

% -------------------------------------------------------------------
% SURFACE

if ~isempty(A.surf.curve.import)
  fprintf(A.proj.notify.import,[A.proj.directory A.surf.curve.import]);
  A.surf.curve.points=load([A.proj.directory A.surf.curve.import]);
end

if ~isempty(A.surf.curve.points)
  A.surf.curve.x=A.surf.curve.points(:,1);
  A.surf.curve.y=A.surf.curve.points(:,2);
  if isempty(A.surf.min.x)
    A.surf.min.x=min(A.surf.curve.x);
  end
  if isempty(A.surf.max.x)
    A.surf.max.x=max(A.surf.curve.x);  
  end
end

if ~isempty(A.surf.curve.rotation.degrees)
  A.surf.curve.rotation.radians=A.surf.curve.rotation.degrees/180*pi;  
  A.surf.curve.rotation.from=min(A.surf.curve.rotation.radians);
  A.surf.curve.rotation.to  =max(A.surf.curve.rotation.radians);
  A.surf.curve.max.y=max(A.surf.curve.y);
  if isempty(A.surf.min.y)
    A.surf.min.y=A.surf.curve.max.y*sin(A.surf.curve.rotation.from);
  end
  if isempty(A.surf.max.y)
    A.surf.max.y=A.surf.curve.max.y*sin(A.surf.curve.rotation.to  );
  end
end

% MANIFESTED:::   SURF {MIN MAX}.{X Y}

A.surf.abs.x=A.surf.max.x-A.surf.min.x;
A.surf.abs.y=A.surf.max.y-A.surf.min.y;

% more options later
if numel(A.surf.samples.numel)==1
  ds=sqrt(A.surf.abs.x*A.surf.abs.y/A.surf.samples.numel);
  A.surf.samples.x=linspace(A.surf.min.x,A.surf.max.x,round(A.surf.abs.x/ds));
  A.surf.samples.y=linspace(A.surf.min.y,A.surf.max.y,round(A.surf.abs.y/ds));
  A.surf.samples.dx=A.surf.samples.x(2)-A.surf.samples.x(1); %only defined when uniform grid!
  A.surf.samples.dy=A.surf.samples.y(2)-A.surf.samples.y(1);  
end

[A.surf.x,A.surf.y]=meshgrid(A.surf.samples.x,A.surf.samples.y);  

% MANIFESTED:::   SURF X.Y

if ~isempty(A.surf.curve.rotation.degrees)
  r=interp1(A.surf.curve.x,A.surf.curve.y,A.surf.x,A.surf.curve.interp.method);
  A.surf.z=sqrt(r.*r-A.surf.y.*A.surf.y);
  A.surf.z(find(imag(A.surf.z)))=NaN;
  a=asin(A.surf.y./r);
  A.surf.z(find(a<A.surf.curve.rotation.from|A.surf.curve.rotation.to<a))=NaN;
  
  %------------------------------------------------------------------
  %http://www.math.cornell.edu/~henderson/courses/M121-F01/Week14.htm  
  A.surf.curve.interp.x  =A.surf.x(1,:)';
  A.surf.curve.interp.y  =interp1(A.surf.curve.x,A.surf.curve.y,A.surf.curve.interp.x,A.surf.curve.interp.method);    
  A.surf.curve.interp.yx =gradient(A.surf.curve.interp.y ,A.surf.curve.interp.x);
  A.surf.curve.interp.yxx=gradient(A.surf.curve.interp.yx,A.surf.curve.interp.x);
  k=-A.surf.curve.interp.yxx./(A.surf.curve.interp.y.*(1+(A.surf.curve.interp.yx.*A.surf.curve.interp.yx).^2));
  k(find(abs(k)<1e-3))=eps;
  A.surf.curvature.gauss.section.c=k;
  %------------------------------------------------
  %http://en.wikipedia.org/wiki/Radius_of_curvature  
  A.surf.curvature.gauss.section.radiusofcurvature=max(min(1./k,100),-100);
  
  if ~isempty(A.proj.export)
    fprintf(A.proj.notify.export,xCSV([A.surf.curve.interp.x A.surf.curvature.gauss.section.c],[A.proj.directory 'target_curve_gauss_curv'] ,A.proj.csv))
    fprintf(A.proj.notify.export,xCSV([A.surf.curve.interp.x A.surf.curvature.gauss.section.radiusofcurvature],[A.proj.directory 'target_curve_radiusofcurv'],A.proj.csv))
  end
  
end

if ~isempty(A.surf.function)
  x=A.surf.x;
  y=A.surf.y;
  A.surf.z=eval(A.surf.function);
end

if ~isempty(A.proj.export)
  fprintf(A.proj.notify.export,xCSV(A.surf.x',[A.proj.directory 'target_surface_x'],A.proj.csv))
  fprintf(A.proj.notify.export,xCSV(A.surf.y',[A.proj.directory 'target_surface_y'],A.proj.csv))
  fprintf(A.proj.notify.export,xCSV(A.surf.z',[A.proj.directory 'target_surface_z'],A.proj.csv))
end

A.surf.min.z=min(min(A.surf.z));
A.surf.max.z=max(max(A.surf.z));
A.surf.abs.z=A.surf.max.z-A.surf.min.z;

% MANIFESTED:::   SURF Z

[A.surf.norm.x,A.surf.norm.y,A.surf.norm.z]=surfnorm(A.surf.x,A.surf.y,A.surf.z);

d=linspace(0,min(A.surf.abs.x,A.surf.abs.y)/2,10);
for c1=1:length(d)
  dx=A.surf.x+A.surf.norm.x*d(c1);
  dy=A.surf.y+A.surf.norm.y*d(c1);
  dz=A.surf.z+A.surf.norm.z*d(c1);
  [Nx,Ny,Nz]=surfnorm(dx,dy,dz);
  pN=Nx.*A.surf.norm.x+Ny.*A.surf.norm.y+Nz.*A.surf.norm.z;
  f=find(pN<0);
  if ~isempty(f)
    break;
  end
end

A.surf.limits.x=A.surf.x(f);
A.surf.limits.y=A.surf.y(f);
A.surf.limits.z=A.surf.z(f);

d=linspace(d(c1-1),d(c1),50);
for c1=1:length(d)
  dx=A.surf.x+A.surf.norm.x*d(c1);
  dy=A.surf.y+A.surf.norm.y*d(c1);
  dz=A.surf.z+A.surf.norm.z*d(c1);
  [Nx,Ny,Nz]=surfnorm(dx,dy,dz);
  pN=Nx.*A.surf.norm.x+Ny.*A.surf.norm.y+Nz.*A.surf.norm.z;
  f=find(pN<0);
  if ~isempty(f)
    break;
  end
end

A.surf.radius=d(c1-1);
A.surf.ref=A.surf.z;

A.surface.x=A.surf.x+A.surf.norm.x*A.drill.radius;
A.surface.y=A.surf.y+A.surf.norm.y*A.drill.radius;
A.surface.z=A.surf.z+A.surf.norm.z*A.drill.radius-A.drill.radius;
A.surface.ref=A.surface.z;

f=find(isnan(A.surf.z));
A.surf.z(f)=A.surf.min.z;

%f=find(isnan(A.surface.x));
%A.surface.x(f)=A.surf.x(f);
%f=find(isnan(A.surface.y));
%A.surface.y(f)=A.surf.y(f);
%f=find(isnan(A.surface.z));
%A.surf.min.z;
%A.surface.z(f)=A.surf.min.z;
%A.surface.z

if ~isempty(A.surf.figure)
  A.surf.figure=figure(A.surf.figure); clf reset
  set(A.surf.figure,'Name','target surface and result after milling')
  set(A.surf.figure,'Color',[1 1 1]);
  subplot(1,2,1)
  surfl(A.surf.x,A.surf.y,A.surf.z)
  hold on   
  surfl(A.surface.x,A.surface.y,A.surface.z)
  axis equal; 
  title(['maximum drill radius = ' num2str(A.surf.radius)])
  hnd=plot3(A.surf.limits.x,A.surf.limits.y,A.surf.limits.z,'.');
  set(hnd,'Color',[0 0 0]);
  set(hnd,'MarkerSize',8);
  xlabel('x'); ylabel('y'); zlabel('z');
  %subplot(1,2,2)
  %contour(A.surf.z,20)
  
end
%return

A.surf.curvature.mean.c   = xmeancurvature(A.surf.x,A.surf.y,A.surf.ref);
A.surf.curvature.gauss.c  =xgausscurvature(A.surf.x,A.surf.y,A.surf.ref);
warning off
A.surf.curvature.gauss.inv=1./A.surf.curvature.gauss.c;
warning on

if ~isempty(A.proj.export)
  fprintf(A.proj.notify.export,xCSV(A.surf.curvature.mean.c'   ,[A.proj.directory 'target_surface_mean_curvature'    ],A.proj.csv))
  fprintf(A.proj.notify.export,xCSV(A.surf.curvature.gauss.c'  ,[A.proj.directory 'target_surface_gauss_curvature'   ],A.proj.csv))
  fprintf(A.proj.notify.export,xCSV(A.surf.curvature.gauss.inv',[A.proj.directory 'target_surface_radiusof_curvature'],A.proj.csv))
end

if ~isempty(A.surf.curvature.figure)
  hnd=figure(A.surf.curvature.figure); clf reset
  set(hnd,'Name','curvature')
  subplot('Position',[.05 .05 .40 .40]); surf(A.surf.x,A.surf.y,A.surf.z,A.surf.curvature.mean.c); title('mean curvature');
  shading interp; colorbar; hold on;
  mesh(A.surf.x,A.surf.y,repmat(min(min(A.surf.z)),size(A.surf.z)),A.surf.curvature.mean.c);
  axis equal; xlabel('x'); ylabel('y'); zlabel('z');  
  subplot('Position',[.05 .55 .40 .40]); surf(A.surf.x,A.surf.y,A.surf.z,A.surf.curvature.gauss.c); title('gauss curvature');
  shading interp; colorbar; hold on;
  mesh(A.surf.x,A.surf.y,repmat(min(min(A.surf.z)),size(A.surf.z)),A.surf.curvature.gauss.c);
  axis equal; xlabel('x'); ylabel('y'); zlabel('z');  
  if ~isempty(A.surf.curve.rotation.degrees)
    subplot('Position',[.55 .55 .40 .40]);
    plot(A.surf.curve.interp.x,A.surf.curvature.gauss.section.c);
    title('cross section of gauss curvature function'); grid on
    subplot('Position',[.55 .05 .40 .40]);
    plot(A.surf.curve.interp.x,A.surf.curvature.gauss.section.radiusofcurvature);
    title('cross section of radius of curvature function'); grid on
  end
end

% -------------------------------------------------------------------
% DRILL

if ~isempty(A.drill.slant.degrees)
  A.drill.slant.radians=A.drill.slant.degrees*pi/180;
end

if ~isempty(A.drill.shape)
  switch A.drill.shape
    case 'balltip'
      t=linspace(0,pi/2,A.drill.interp.resolution);
      A.drill.interp.x=A.drill.radius*sin(t);
      A.drill.interp.y=A.drill.radius*(1-cos(t));
    case 'spherical'
      A.drill.lever=A.drill.radius/sin(A.drill.slant.radians);
      t=linspace(0,A.drill.slant.radians,A.drill.interp.resolution);
      A.drill.interp.x=A.drill.lever*sin(t);
      A.drill.interp.y=A.drill.lever*(1-cos(t));
    case 'conic'
      A.drill.interp.x=linspace(0,A.drill.radius,A.drill.interp.resolution);    
      A.drill.interp.y=A.drill.interp.x*tan(A.drill.slant.radians);
    case 'freeform'
      % user predefines A.drill.interp.x and A.drill.interp.y
      A.drill.radius=A.drill.interp.x(end);
    otherwise
      error(['unknown drill shape: ' A.drill.shape])
  end
end

A.drill.interp.step.x=A.drill.interp.x(2);
A.drill.variation=A.drill.interp.y(end);
A.drill.csection.x=[-fliplr(A.drill.interp.x) A.drill.interp.x(2:end)];
A.drill.csection.z=[ fliplr(A.drill.interp.y) A.drill.interp.y(2:end)];

A.mill.stencil.radius=A.drill.radius*.97;
[x,y]=meshgrid(linspace(-A.mill.stencil.radius,A.mill.stencil.radius,A.mill.stencil.resolution));
z=interp1(A.drill.interp.x,A.drill.interp.y,sqrt(x.*x+y.*y),'linear');
z(find(isnan(z)))=Inf;

A.mill.stencil.x=x;
A.mill.stencil.y=y;
A.mill.stencil.z=z;
A.mill.stencil.step.x=diff(A.mill.stencil.x(1,1:2));

if ~isempty(A.drill.figure)
  hnd=figure(A.drill.figure); clf reset
  set(hnd,'Name','cross section and stencil of drill');
  set(hnd,'Color',[1 1 1]);
  subplot(1,2,1);
  plot(A.drill.csection.x,A.drill.csection.z); hold on;
  plot(A.drill.csection.x,A.drill.csection.z,'r*');
  plot(+[A.drill.radius A.drill.radius],A.drill.variation+[0 .5*A.drill.radius]);
  plot(-[A.drill.radius A.drill.radius],A.drill.variation+[0 .5*A.drill.radius]);
  hold off
  axis equal;
  grid on;
  title(['drill radius used = ' num2str(A.drill.radius)]);
  subplot(1,2,2);
  surfl(A.mill.stencil.x,A.mill.stencil.y,A.mill.stencil.z);
  title('stencil');
  axis equal;
end

% -------------------------------------------------------------------
% PATH

if ~isempty(A.path.parallel.lines.x)
  A.path.parallel.x=linspace(A.surf.min.x,A.surf.max.x,A.path.parallel.lines.x);
end

if ~isempty(A.path.parallel.lines.y)
  A.path.parallel.y=linspace(A.surf.min.y,A.surf.max.y,A.path.parallel.lines.y);
end

if ~isempty(A.surf.curve.rotation.degrees)
  %if ~isempty(A.path.streamlines)
  %  [A.path.mesh.x,T]=meshgrid(A.surf.curve.x,A.surf.curve.rotation.radians);
  %  r=repmat(A.surf.curve.y,[1 numel(A.surf.curve.rotation.radians)])';
  %  A.path.mesh.y=sin(T).*r;
  %  A.path.mesh.z=cos(T).*r;  
  %end
  if ~isempty(A.path.parallel.y) % ENCORPORATE parallel.x  
    [A.path.mesh.x,A.path.mesh.y]=meshgrid(A.surf.curve.x,A.path.parallel.y);
    r=interp1(A.surf.curve.x,A.surf.curve.y,A.path.mesh.x,'linear');
    A.path.mesh.z=sqrt(r.*r-A.path.mesh.y.*A.path.mesh.y);
    A.path.mesh.z(find(imag(A.path.mesh.z)))=NaN;
    a=asin(A.path.mesh.y./r);
    A.path.mesh.z(find(a<A.surf.curve.rotation.from|A.surf.curve.rotation.to<a))=NaN;
    A.path.mesh.z(find(isnan(A.path.mesh.z)))=min(min(A.surf.z));
  end
end

if ~isempty(A.path.import.filename)
  switch lower(A.path.import.filename(end-2:end))
  case 'ncc'
    [A.path.points,A.path.tools]=xNCCread([A.proj.directory A.path.import.filename]);
    fprintf(A.proj.notify.import,[A.proj.directory A.path.import.filename]);
  end  
  
  A.path.master.x=A.path.points{A.path.import.index}(:,A.path.import.permute(1))+A.path.import.translation(1);
  A.path.master.y=A.path.points{A.path.import.index}(:,A.path.import.permute(2))+A.path.import.translation(2);
  A.path.master.z=A.path.points{A.path.import.index}(:,A.path.import.permute(3))+A.path.import.translation(3);
  
  if ~isempty(A.path.import.figure)
    [U,tmp,A.path.colors]=unique(A.path.tools);
    hnd=figure(A.path.import.figure); clf reset
    set(hnd,'Name','imported toolpath');
    for c1=1:length(A.path.points)
      plot3(A.path.points{c1}(:,1),A.path.points{c1}(:,2),A.path.points{c1}(:,3),A.path.palette{A.path.colors(c1)});
      hold on
    end
    
    xlabel('x'); ylabel('y'); zlabel('z');
    axis equal
    grid on
    view(0,0)
  end
  
end

if ~isempty(A.surf.function)&isempty(A.path.x)
  [A.path.mesh.x,A.path.mesh.y]=meshgrid(A.path.parallel.x,A.path.parallel.y);
  x=A.path.mesh.x;
  y=A.path.mesh.y;
  A.path.mesh.z=eval(A.surf.function);
end

% GENERATE PATH FROM MESH

if ~isempty(A.path.mesh.z)                              
  [A.path.master.x,A.path.master.y,A.path.master.z]=xtoolpath(A.path.mesh.x,A.path.mesh.y,A.path.mesh.z,A.path.direction);
  f=find(isnan(A.path.master.x+A.path.master.y+A.path.master.z));
  A.path.master.x(f)=[];
  A.path.master.y(f)=[];
  A.path.master.z(f)=[];
  lx=length(A.path.master.x);
  nx=lx;
  while nx<A.path.numel
    nx=2*nx;
  end
  nx=nx+1;
  %lx
  %nx
  A.path.master.x=interp1(A.path.master.x,linspace(1,lx,nx)');
  A.path.master.y=interp1(A.path.master.y,linspace(1,lx,nx)');
  A.path.master.z=interp1(A.path.master.z,linspace(1,lx,nx)');
end

% LAYOUT TOOLPATH

if ~isempty(A.path.mesh.x)
  if strcmp(A.drill.shape,'balltip')    
    dx=A.surf.x+A.surf.norm.x*A.drill.radius;
    dy=A.surf.y+A.surf.norm.y*A.drill.radius;
    dz=A.surf.z+A.surf.norm.z*A.drill.radius;
    px=A.path.master.x;
    py=A.path.master.y;
    A.path.master.x=interp2(A.surf.x,A.surf.y,dx,px,py);
    A.path.master.y=interp2(A.surf.x,A.surf.y,dy,px,py);
    A.path.master.z=interp2(A.surf.x,A.surf.y,dz,px,py)-A.drill.radius;
  end
end

if ~isempty(A.path.contour.lines)
  px=[];
  py=[];
  pz=[];
  hnd=figure(A.path.contour.figure+0); clf reset
  set(hnd,'Name','contour lines')
  [c,h]=contour(A.surface.x,A.surface.y,A.surface.z,A.path.contour.lines);
  clabel(c,h), colorbar
  hnd=figure(A.path.contour.figure+1); clf reset
  set(hnd,'Name','contour lines in 3d')
  set(hnd,'Color',[1 1 1]);
  cnt=1;
  mz=A.surf.max.z;
  lc=c(:,2);  
  while cnt<size(c,2)
    n=c(2,cnt);
    if n>4
      plot3(c(1,cnt+[1:n]),c(2,cnt+[1:n]),repmat(c(1,cnt),[1 n]));
      hold on
      n1=c(:,cnt+1);
      n2=c(:,cnt+n);
      if norm(n1-lc)<norm(n2-lc)
        np=[1 1:n n];
      else
        np=[n n:-1:1 1];
      end
      px=[px;c(1,cnt+np)'];
      py=[py;c(2,cnt+np)'];
      pz=[pz;mz;repmat(c(1,cnt),[n 1]);mz];
    end
    cnt=cnt+n+1;
  end
  xlabel('x'); ylabel('y'); zlabel('z');
  axis equal
  A.path.master.x=px;
  A.path.master.y=py;
  A.path.master.z=pz;
end

if ~isempty(A.surf.curve.rotation.degrees) %pass the line
  if ~isempty(A.path.streamlines)
    [A.path.mesh.x,T]=meshgrid(A.surf.curve.x,A.surf.curve.rotation.radians);
    r=repmat(A.surf.curve.y+A.drill.radius,[1 numel(A.surf.curve.rotation.radians)])';    
    %R=r+A.drill.radius*abs(sin(T));
    A.path.mesh.y=sin(T).*r;
    A.path.mesh.z=cos(T).*r-A.drill.radius;
    [A.path.master.x,A.path.master.y,A.path.master.z]=xtoolpath(A.path.mesh.x,A.path.mesh.y,A.path.mesh.z,A.path.direction);
  end
end

%------------------------------------------
% WHENEVER CORRECTION IS APPLIED

if isempty(A.path.master.x)&~isempty(A.path.x)
  [A.path.master.x,A.path.master.y,A.path.master.z]=deal(A.path.x,A.path.y,A.path.z);
end
  
A.path.master.dx=diff(A.path.master.x);
A.path.master.dy=diff(A.path.master.y);
A.path.master.ds=sqrt(A.path.master.dx.*A.path.master.dx+A.path.master.dy.*A.path.master.dy);
A.path.master.parameter=[0;cumsum(A.path.master.ds)];
A.path.master.sampling=A.path.master.parameter;
A.path.master.radius=xradiusofcurvature(A.path.master.sampling,A.path.master.z); 
  
if ~strcmp('',A.path.correct.method);
  A.path.master.sampling=[0:A.drill.interp.step.x:A.path.master.parameter(end)]';
  A.path.master.x=interp1(A.path.master.parameter,A.path.master.x,A.path.master.sampling,'linear');
  A.path.master.y=interp1(A.path.master.parameter,A.path.master.y,A.path.master.sampling,'linear');
  A.path.master.z=interp1(A.path.master.parameter,A.path.master.z,A.path.master.sampling,'linear');
  A.path.master.radius=xradiusofcurvature(A.path.master.sampling,A.path.master.z); 
end

if ~isempty(A.path.master.figure)
  hnd=figure(A.path.master.figure); clf reset
  set(hnd,'Name','parameters along the toolpath domain')
  subplot(2,1,1); plot(A.path.master.sampling,A.path.master.z,'b-');    
  title('height');
  subplot(2,1,2); plot(A.path.master.sampling,min(10,A.path.master.radius),'b-');    
  title('min(10,radius of curvature)')
end

[A.path.x,A.path.y,A.path.z]=deal(A.path.master.x,A.path.master.y,A.path.master.z);

if 0<A.path.segmentation.angle
  ang=xangles(A.path.master.x,A.path.master.y,A.path.master.z);
  ang([1 end])=pi;
  f=find(ang>A.path.segmentation.angle);
  [A.path.x,A.path.y,A.path.z]=deal(A.path.master.x(f),A.path.master.y(f),A.path.master.z(f));
end

f=find(isnan(A.path.x+A.path.y+A.path.z));

A.path.x(f)=[];
A.path.y(f)=[];
A.path.z(f)=[];

% -------------------------------------------------------------------
% MANIFESTED:::   PATH X.Y.Z

if ~isempty(A.proj.export)
  A.path.export.x=A.path.x+A.path.export.translation(1);
  A.path.export.y=A.path.y+A.path.export.translation(2);
  A.path.export.z=A.path.z+A.path.export.translation(3);
  fprintf(A.proj.notify.export,xCSV(    [A.path.export.x A.path.export.y A.path.export.z],[A.proj.directory 'toolpath'],A.proj.csv));  
  fprintf(A.proj.notify.export,xDXFline3(A.path.export.x,A.path.export.y,A.path.export.z ,[A.proj.directory 'toolpath']));
  fprintf(A.proj.notify.export,xNCCline3(A.path.export.x,A.path.export.y,A.path.export.z ,[A.proj.directory 'toolpath']));
end

if ~isempty(A.path.figure)
  hnd=figure(A.path.figure); clf reset
  set(hnd,'Name','final toolpath');
  set(hnd,'Color',[1 1 1]);
  plot3(A.path.x,A.path.y,A.path.z,'b-');
  hold on; axis equal
  plot3(A.path.x,A.path.y,A.path.z,'rx')
  xlabel('x'); ylabel('y'); zlabel('z');
end

dx=diff(A.path.x);
dy=diff(A.path.y);
dz=diff(A.path.z);
A.path.segments=numel(dx);
A.path.segment.index=[1:A.path.segments]';
A.path.segment.dx=dx;
A.path.segment.dy=dy;
A.path.segment.dz=dz;
A.path.segment.ds=sqrt(dx.*dx+dy.*dy);
A.path.segment.length=sqrt(dx.*dx+dy.*dy+dz.*dz);
A.path.segment.angle=angle(dx+i*dy);
A.path.segment.turn=xangles(A.path.x,A.path.y,zeros(size(A.path.x)));
A.path.segment.slope=dz./A.path.segment.ds;
A.path.segment.elevation=angle(A.path.segment.ds+i*dz);
A.path.parameter=[0;cumsum(sqrt(dx.*dx+dy.*dy))];
A.path.length=A.path.parameter(end);
A.path.angle=xangles(A.path.x,A.path.y,A.path.z);
A.path.min.x=min(A.path.x);
A.path.min.y=min(A.path.y);
A.path.max.x=max(A.path.x);
A.path.max.y=max(A.path.y);

if ~isempty(A.proj.export)
  s=[A.path.segment.index A.path.segment.length A.path.segment.elevation*180/pi];
  fprintf(A.proj.notify.export,xCSV(s,[A.proj.directory 'toolpath_segments'],'%4i;%8.4f;%8.4f','Index;Length;Elevation (degree)'));
end

%A.path.radiusOfCurvature=zeros(size(A.path.x)); %+Inf; formally the value is Inf
%for c1=2:numel(A.path.x)-1
%  [c,A.path.radiusOfCurvature(c1,:)]=xspherefit([ A.path.parameter(c1-1) A.path.z(c1-1)
%                                                  A.path.parameter(c1+0) A.path.z(c1+0)
%                                                  A.path.parameter(c1+1) A.path.z(c1+1) ]);
%end

if ~isempty(A.path.analysis.figure)
  hnd=figure(A.path.analysis.figure); clf reset
  set(hnd,'Name','path analysis')
  subplot(3,1,1);
    plot(A.path.segment.length,'-b');
    title(['length of segments (total length of toolpath in 3D = ' num2str(A.path.length) ')']);
    grid on;
  subplot(3,1,2);
    ele=A.path.segment.elevation*180/pi;
    plot(ele,'-r');
    title(['elevation of segment (maximum=' num2str(max(abs(ele))) ')']);
    grid on;
  subplot(3,1,3);
    ang=A.path.segment.turn*180/pi;
    plot(1:length(ang),ang,'-g');
    title(['angles of x-y turning between segments (maximum=' num2str(max(abs(ang))) ')']);
    xlabel('index of segment')
    grid on;  
  %fprintf('toolpath %10s = %10i\n','#segments',length(A.path.x)-1);
end


% -------------------------------------------------------------------
% MILLING SIMULATION
% -------------------------------------------------------------------

fprintf(' i milling simulation:\n # points in domain     = %8i\n # segments of toolpath = %8i\n',numel(A.surf.x),A.path.segments)

A.mill.x=A.surf.x;
A.mill.y=A.surf.y;
A.mill.z=repmat(Inf,size(A.mill.x));

n=(size(A.mill.stencil.x,2)+1)/2;
dx=A.mill.stencil.step.x;
sx=A.mill.stencil.x(1,:);
Sx=A.mill.stencil.x;
Sy=A.mill.stencil.y;
Sz=A.mill.stencil.z;

tic

for c1=1:A.path.segments
  xscale(c1,A.path.segments)
  len=A.path.segment.ds(c1);
  slo=A.path.segment.slope(c1);
  zl=Sz;
  zr=Sz;
  di=1;
  while di<size(z,2)&dx*di<len
    zl(:,di+1:end)=min(zl(:,di+1:end),zl(:,1:end-di)+slo*dx*di);
    zr(:,1:end-di)=min(zr(:,1:end-di),zr(:,di+1:end)-slo*dx*di);
    di=di+1;
  end
  if slo<0
    f=find(len+sx>0);
    f=f(1);
    x=[Sx(:,1:n) Sx(:,f:end)+len    ];
    y=[Sy(:,1:n) Sy(:,f:end)];
    z=[zl(:,1:n) zr(:,f:end)+len*slo];
  else
    f=find(sx<len);
    f=f(end);
    x=[Sx(:,1:f) Sx(:,n:end)+len    ];
    y=[Sy(:,1:f) Sy(:,n:end)];
    z=[zl(:,1:f) zr(:,n:end)+len*slo];
  end
  X=A.mill.x-A.path.x(c1);
  Y=A.mill.y-A.path.y(c1);  
  a=-A.path.segment.angle(c1);    
  [X,Y]=deal( cos(a)*X-sin(a)*Y , sin(a)*X+cos(a)*Y );
  A.mill.z=min(A.mill.z,interp2(x,y,z+A.path.z(c1),X,Y,'linear'));
end

t=toc;
fprintf(' # seconds elapsed      = %8i\n',round(t));

A.mill.e=A.mill.z-A.surf.ref;
f=find(isnan(A.surf.ref)&~isinf(A.mill.z));
A.mill.e(f)=0;
A.mill.r=A.mill.e*100/max(max(abs(A.mill.e)));


if ~isempty(A.surf.figure)
  figure(A.surf.figure);
  subplot(1,2,2)
  surfl(A.mill.x,A.mill.y,A.mill.z)
  axis equal; hold on  
  xlabel('x'); ylabel('y'); zlabel('z');
end


if ~isempty(A.surf.curve.rotation.radians)
  n=35;
  x=linspace(A.surf.min.x,A.surf.max.x,n)';
  y=interp2(A.mill.x,A.mill.y,A.mill.z,x,zeros(n,1),'linear');
  fprintf(A.proj.notify.export,xCSV([x y],[A.proj.directory 'milled_cross-section_center'],A.proj.csv));
  [x y];
end

if ~isempty(A.proj.export)
  fprintf(A.proj.notify.export,xCSV(A.mill.z,[A.proj.directory 'milled_surface'],A.proj.csv));
  fprintf(A.proj.notify.export,xCSV(A.mill.e,[A.proj.directory 'deviation_abs'],A.proj.csv));
  fprintf(A.proj.notify.export,xCSV(A.mill.r,[A.proj.directory 'deviation_rel'],A.proj.csv));
end

if ~isempty(A.mill.figure)
  hnd=figure(A.mill.figure); clf reset
  set(hnd,'Name','milling simulation');
  set(hnd,'Color',[1 1 1]);
  subplot('Position',[.1 .1 .8 .8]);
  A.mill.c=max(-5,min(A.mill.e,5));
  surf(A.mill.x,A.mill.y,A.mill.z,A.mill.c);
  alpha(.95);
  shading interp;
  colormap hsv; colorbar;
  view(50,20)
  hold on;  
  mesh(A.mill.x,A.mill.y,repmat(min(min(A.mill.z)),size(A.mill.z)),A.mill.c);
  hnd=plot3(A.path.x,A.path.y,A.path.z+eps,'k');  
  set(hnd,'LineWidth',1.5);
  axis equal;
  xlabel('x'); ylabel('y'); zlabel('z');
  
  hnd=figure(A.mill.figure+1); clf reset
  set(hnd,'Name','deviation');
  subplot('Position',[.1 .1 .8 .8]); 
  mesh(A.mill.x,A.mill.y,A.mill.e);
  colormap hsv;
  colorbar;
  axis equal;
  xlabel('x'); ylabel('y'); zlabel('z');
  
  if ~isempty(A.mill.plot.section.x)  
    hnd=figure(A.mill.figure+2); clf reset
    set(hnd,'Name','cross sections');
    surfl(A.surf.x,A.surf.y,A.surf.z)
    alpha(.4);
    hold on
    n=200;    
    sy=linspace(A.surf.min.y,A.surf.max.y,n)';        
    for c1=1:length(A.mill.plot.section.x)
      sx=repmat(A.mill.plot.section.x(c1),[n 1]);      
      sz=interp2(A.mill.x,A.mill.y,A.mill.z,sx,sy,'linear');
      f=find(~isinf(sz)&~isnan(sz));
      [px,py,pz]=deal(sx(f),sy(f),sz(f));
      hnd=plot3(px,py,pz,'r');
      set(hnd,'LineWidth',1.5);
      sz=interp2(A.mill.x,A.mill.y,A.mill.e,sx,sy,'linear');
      f=find(~isinf(sz)&~isnan(sz));
      [px,py,pz]=deal(sx(f),sy(f),sz(f));
      hnd=plot3(px,py,pz,'k');
      set(hnd,'LineWidth',1.5);
    end
    axis equal; 
    title(['at x =' sprintf(' %.2f',A.mill.plot.section.x)]);
    legend('target surface','milling','deviation');
    grid on;
  
    hnd=figure(A.mill.figure+3); clf reset
    set(hnd,'Name','cross section');
    n=200;    
    sy=linspace(A.surf.min.y,A.surf.max.y,n)';        
    for c1=1:length(A.mill.plot.section.x)
      subplot(length(A.mill.plot.section.x),1,c1);
      sx=repmat(A.mill.plot.section.x(c1),[n 1]);
      sz=interp2(A.surf.x,A.surf.y,A.surf.z,sx,sy,'linear');
      f=find(~isinf(sz)&~isnan(sz));
      [px,py,pz]=deal(sx(f),sy(f),sz(f));
      plot(py,pz,'b');
      hold on;      
      sz=interp2(A.mill.x,A.mill.y,A.mill.z,sx,sy,'linear');
      f=find(~isinf(sz)&~isnan(sz));
      [px,py,pz]=deal(sx(f),sy(f),sz(f));
      plot(py,pz,'r');
      sz=interp2(A.mill.x,A.mill.y,A.mill.e,sx,sy,'linear');
      f=find(~isinf(sz)&~isnan(sz));
      [px,py,pz]=deal(sx(f),sy(f),sz(f));      
      plot(py,pz,'k');
      title(['at x=' num2str(A.mill.plot.section.x(c1))]);
      grid on;
      axis([A.surf.min.y A.surf.max.y A.surf.min.z-6 Inf]);      
      axis equal;      
    end
    legend('target','milling','deviation');
  end
end

disp(' i done');
